from math import sqrt, ceil
from operator import add

def _calculate_factors(x):
    factors = [1]
    sqrt_x = int(ceil(sqrt(x)))
    for i in xrange(2, sqrt_x):
        if x % i == 0:
            factors.append(i)
            factors.append(x // i)
            
    if sqrt_x ** 2 == x: factors.append(sqrt_x)
    return factors

def is_perfect(x):
    return reduce(add, _calculate_factors(x), 0) == x
